diff -r 1d1c4c997b66 sys/netinet/tcp_output.c
--- a/sys/netinet/tcp_output.c	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/netinet/tcp_output.c	Sun Aug 30 14:27:42 2015 +1000
@@ -37,10 +37,13 @@
 #include "opt_ipsec.h"
 #include "opt_tcpdebug.h"
 
+#include <sys/endian.h>
+
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/domain.h>
 #include <sys/hhook.h>
+#include <sys/kdb.h>
 #include <sys/kernel.h>
 #include <sys/lock.h>
 #include <sys/mbuf.h>
@@ -50,6 +53,7 @@
 #include <sys/socket.h>
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
+#include <sys/taskqueue.h>
 
 #include <net/if.h>
 #include <net/route.h>
@@ -80,7 +84,9 @@
 #ifdef TCP_OFFLOAD
 #include <netinet/tcp_offload.h>
 #endif
-
+#include <netinet/mptcp.h>
+#include <netinet/mptcp_pcb.h>
+#include <netinet/mptcp_var.h>
 #ifdef IPSEC
 #include <netipsec/ipsec.h>
 #endif /*IPSEC*/
@@ -94,7 +100,7 @@
 	&VNET_NAME(path_mtu_discovery), 1,
 	"Enable Path MTU Discovery");
 
-VNET_DEFINE(int, tcp_do_tso) = 1;
+VNET_DEFINE(int, tcp_do_tso) = 0;
 #define	V_tcp_do_tso		VNET(tcp_do_tso)
 SYSCTL_INT(_net_inet_tcp, OID_AUTO, tso, CTLFLAG_VNET | CTLFLAG_RW,
 	&VNET_NAME(tcp_do_tso), 0,
@@ -128,6 +134,9 @@
 			    long len, int tso);
 static void inline	cc_after_idle(struct tcpcb *tp);
 
+static void inline 	mp_addoptions(struct tcpopt *to,
+				u_int *optlen_ptr, u_char *optp);
+
 /*
  * Wrapper for the TCP established output helper hook.
  */
@@ -161,6 +170,369 @@
 		CC_ALGO(tp)->after_idle(tp->ccv);
 }
 
+static void inline
+mp_addoptions(struct tcpopt *to, u_int *optlen_ptr, u_char *optp) {
+	struct mp_capable mcap;
+
+	uint64_t mask = 0;
+	for (mask = 1; mask < MPOF_MAXOPT; mask <<= 1) {
+		if ((to->to_mopts.mpo_flags & mask) != mask)
+			continue;
+		if (*optlen_ptr == TCP_MAXOLEN)
+			break;
+		switch (to->to_mopts.mpo_flags & mask)
+		{
+		case MPOF_CAPABLE_SYN:
+		{
+			/*
+			 * Note that keys are stored in network order, so
+			 * do no need to call htobe64 before bcopy
+			 */
+			mcap.kind = TCPOPT_MPTCP;
+			mcap.ver_sub = MPTCP_SUBTYPE_MP_CAPABLE;
+
+			uint8_t cap_flags = 0;
+			cap_flags |= USE_SHA1; // hard coded in sha1
+			cap_flags &= ~USE_CSUM; // don't support csumming yet
+
+			if (to->to_mopts.mpo_flags & MPOF_USE_CSUM) {
+				cap_flags |= USE_CSUM;
+			}
+			/* sending a SYN */
+
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_CAPABLE_SYN)
+				break;
+
+			mcap.length = MPTCP_SUBLEN_MP_CAPABLE_SYN;
+
+			/* SYN (or SYNACK), just include the local key */
+			u_int64_t key = to->to_mopts.local_key;
+
+			/* MP_CAPABLE type/flags */
+			*optlen_ptr += MPTCP_SUBLEN_MP_CAPABLE_SYN;
+			*optp++ = mcap.kind;
+			*optp++ = mcap.length;
+			*optp++ = 0; // version and subtype are 0
+			*optp++ = cap_flags;
+
+			/* copy in the key s*/
+			bcopy((u_char *)&key, optp, sizeof(key));
+			optp += sizeof(key);
+
+			/*
+			 * Indicate to caller that the capable option has been
+			 * copied into the outgoing TCP header.
+			 */
+			to->to_mopts.mpo_flags &= ~MPOF_CAPABLE_SYN;
+			break;
+		}
+		case MPOF_CAPABLE_ACK:
+		{
+			uint8_t cap_flags = 0;
+			/* ACK of 3-way handshake */
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_CAPABLE_ACK)
+				break;
+
+			u_int64_t local_key = to->to_mopts.local_key;
+			u_int64_t remote_key = to->to_mopts.remote_key;
+
+			*optlen_ptr += MPTCP_SUBLEN_MP_CAPABLE_ACK;
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_CAPABLE_ACK;
+			*optp++ = 0;	// just manually setting
+			*optp++ = cap_flags;
+
+			/* and copy in the local key */
+			bcopy((u_char *)&local_key, optp, sizeof(local_key));
+			optp += sizeof(local_key);
+
+			/* echo the remote key */
+			bcopy((u_char *)&remote_key, optp, sizeof(remote_key));
+			optp += sizeof(remote_key);
+
+			break;
+		}
+		case MPOF_MP_JOIN: /* Sending a MP_JOIN SYN Option */
+		{
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_JOIN_SYN)
+				break;
+
+			uint8_t subtype = MPTCP_SUBTYPE_MP_JOIN;
+
+			/*
+			 * XXXNJW: just assuming for now that SYNs are sent as subflows
+			 * are added
+			 */
+			uint8_t addrID = to->to_mopts.addr_id;
+			uint32_t remote_token = htonl(to->to_mopts.rcv_token);
+
+			subtype = (subtype << 4);
+
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_JOIN_SYN;
+			*optp++ = (MPTCP_SUBTYPE_MP_JOIN << 4);	// XXXNJW manually setting
+
+			*optlen_ptr += MPTCP_SUBLEN_MP_JOIN_SYN;
+			*optp++ = addrID;
+
+			printf("%s: copied rcv's token %u\n", __func__,                     //XXXNJW
+			    to->to_mopts.rcv_token);
+			printf("%s: rcv token htonl %u\n", __func__,
+					htonl(to->to_mopts.rcv_token));
+
+			bcopy((u_char *)&remote_token,
+					optp, sizeof(remote_token));
+			optp += sizeof(remote_token);
+
+			bcopy((u_char *)&to->to_mopts.snd_rnd,
+					optp, sizeof(to->to_mopts.snd_rnd));
+			optp += sizeof(to->to_mopts.snd_rnd);
+			break;
+		}
+		case MPOF_JOIN_SYN: /* Sending a MP_JOIN SYNACK Option */
+		{
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_JOIN_SYNACK)
+				break;
+
+			uint8_t subtype = MPTCP_SUBTYPE_MP_JOIN;
+			subtype = (subtype << 4);
+
+			*optlen_ptr += MPTCP_SUBLEN_MP_JOIN_SYNACK;
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_JOIN_SYNACK;
+			*optp++ = subtype;
+			*optp++ = (uint8_t) to->to_mopts.addr_id;
+
+			bcopy((u_char *)&to->to_mopts.truncated_MAC,
+			    optp, sizeof(to->to_mopts.truncated_MAC));
+			optp += sizeof(to->to_mopts.truncated_MAC);
+
+			bcopy((u_char *)&to->to_mopts.snd_rnd,
+			    optp, sizeof(to->to_mopts.snd_rnd));
+			optp += sizeof(to->to_mopts.snd_rnd);
+			break;
+		}
+		case MPOF_JOIN_SYNACK: /* Sending a MP_JOIN ACK Option */
+		{
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_JOIN_ACK) {
+				break;
+			}
+
+			uint8_t subtype = MPTCP_SUBTYPE_MP_JOIN;
+			subtype = (subtype << 4);
+
+			*optlen_ptr += (uint8_t) MPTCP_SUBLEN_MP_JOIN_ACK;
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_JOIN_ACK;
+			*optp++ = subtype;
+			/* the last 12-bits after subtype are reserved (zeroed) */
+			*optp++ = 0;
+
+			/* Copy full HMAC-A into option */
+			bcopy(to->to_mopts.snd_mac, optp, 20);
+			optp += 20;
+			break;
+		}
+		case MPOF_DSS:
+		{
+			uint8_t subtype = MPTCP_SUBTYPE_DSS;
+			uint8_t dss_opts = 0;
+			uint8_t length = 4; /* the initial 4 bytes of option */
+
+			/* Set flags for DSS */
+			if (to->to_mopts.mpo_flags & MPOF_DATA_FIN) {
+				printf("%s: setting Data-fin\n", __func__);
+				dss_opts |= FIN_PRESENT;
+			}
+
+			if (to->to_mopts.mpo_flags & MPOF_DATA_ACK) {
+				dss_opts |= ACK_PRESENT;
+				length += 4;
+
+				if (to->to_mopts.mpo_flags & MPOF_ACK64) {
+					dss_opts |= ACK_64_PRESENT;
+					length += 4;
+				}
+			}
+
+			if (to->to_mopts.mpo_flags & MPOF_DSN_MAP) {
+				dss_opts |= MAP_PRESENT;
+				length += 4;
+
+				length += 4;	/* subflow sequence num */
+				length += 2;	/* data length */
+
+				if(to->to_mopts.mpo_flags & MPOF_USE_CSUM)
+					length += 2;
+
+				if (to->to_mopts.mpo_flags & MPOF_DSN64) {
+					length += 4;
+					dss_opts |= DSN_64;
+				}
+			}
+
+			if (TCP_MAXOLEN - *optlen_ptr < length)
+				break;
+
+			*optlen_ptr += length;
+
+			// pad it out to divide by 4 to prevent EOL being inserted
+			// before our option
+			// XXXNJW kind of a hack, to fix
+			if (*optlen_ptr % 4) {
+				*optlen_ptr += TCPOLEN_NOP;
+				*optp++ = TCPOPT_NOP;
+				*optlen_ptr += TCPOLEN_NOP;
+				*optp++ = TCPOPT_NOP;
+			}
+
+			/* option kind and length fields */
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = length;
+
+			/* subtype and flags */
+			subtype = (subtype << 4);
+			bcopy((u_char *)&subtype, optp, sizeof(uint8_t));
+			optp += sizeof(uint8_t);
+//			to->to_mopts.dss_opts_f_p = (uint8_t*) optp;
+			bcopy((u_char *)&dss_opts, optp, sizeof(uint8_t));
+			optp += sizeof(uint8_t);
+
+			/* copy the Data ACK */
+			if (to->to_mopts.mpo_flags & MPOF_DATA_ACK) {
+				if (to->to_mopts.mpo_flags & MPOF_ACK64) {
+					u_int64_t data_ack_num = to->to_mopts.data_ack_num;
+					data_ack_num = htobe64(data_ack_num);
+					bcopy((u_char *)&data_ack_num, optp, sizeof(data_ack_num));
+					optp += sizeof(data_ack_num);
+				} else {
+					u_int32_t data_ack_num =
+					    (uint32_t) to->to_mopts.data_ack_num;
+					data_ack_num = htonl(data_ack_num);
+					bcopy((u_char *)&data_ack_num, optp, sizeof(data_ack_num));
+					optp += sizeof(data_ack_num);
+				}
+			}
+
+			/* DSN contents */
+			if (to->to_mopts.mpo_flags & MPOF_DSN_MAP) {
+				uint32_t data_seq_num = (uint32_t) to->to_mopts.data_seq_num;
+				/* DSN and SSN */
+				if (to->to_mopts.mpo_flags & MPOF_DSN64) {
+					to->to_mopts.data_seq_num =
+							htobe64(to->to_mopts.data_seq_num);
+					bcopy((u_char *)&to->to_mopts.data_seq_num,
+							optp, sizeof(to->to_mopts.data_seq_num));
+					optp += sizeof(to->to_mopts.data_seq_num);
+				} else {
+					data_seq_num = htonl(data_seq_num);
+					bcopy((u_char *)&data_seq_num, optp, sizeof(data_seq_num));
+					optp += sizeof(data_seq_num);
+				}
+
+				to->to_mopts.sub_seq_num = htonl(to->to_mopts.sub_seq_num);
+				bcopy((u_char *)&to->to_mopts.sub_seq_num, optp,
+					sizeof(to->to_mopts.sub_seq_num));
+				optp += sizeof(to->to_mopts.sub_seq_num);
+
+				/* Length */
+				/* set length after we know the size, for a map-per-packet
+				 * scenario */
+				to->to_mopts.dss_data_len_p = optp;
+//				to->to_mopts.dss_data_len = htons(to->to_mopts.dss_data_len);
+//				bcopy((u_char *)&to->to_mopts.dss_data_len, optp,
+//					sizeof(to->to_mopts.dss_data_len));
+				optp += sizeof(to->to_mopts.dss_data_len);
+
+				if(to->to_mopts.mpo_flags & MPOF_USE_CSUM) {
+					to->to_mopts.dss_csum = htons(to->to_mopts.dss_csum);
+					bcopy((u_char *)&to->to_mopts.dss_csum, optp,
+						sizeof(to->to_mopts.dss_csum));
+					optp += sizeof(to->to_mopts.dss_csum);
+				}
+			}
+
+			/*
+			 * We process all at once so can clear flags to prevent
+			 * processing twice.
+			 */
+			to->to_mopts.mpo_flags &= ~MPOF_DSN_MAP;
+			to->to_mopts.mpo_flags &= ~MPOF_DATA_ACK;
+			to->to_mopts.mpo_flags &= ~MPOF_DATA_FIN;
+			break;
+		}
+		case MPOF_ADD_ADDR:
+		{
+			struct mp_add address;
+			int i, addr_id, addr_len = 0;
+			void * addr = NULL;
+
+			address.length = address.sub_ipver = 0;
+
+			/* Loop through the available addresses. */
+			for (i = 0; i < to->to_mopts.address_count; i++) {
+				/* continue if there are addresses to advertise */
+				if (!(to->to_mopts.add_addr_mask & (1 << i)))
+					continue;
+
+				switch (mp_usable_addresses[i].ss_family) {
+					case AF_INET:
+						addr = &((struct sockaddr_in *)
+							&mp_usable_addresses[i])->sin_addr.s_addr;
+						address.length = MPTCP_SUBLEN_ADD_ADDRV4;
+						address.sub_ipver = 4;
+						addr_len = 4;
+						break;
+					case AF_INET6:
+						addr = &((struct sockaddr_in6 *)
+							&mp_usable_addresses[i])->sin6_addr.__u6_addr;
+						address.length = MPTCP_SUBLEN_ADD_ADDRV6;
+						address.sub_ipver = 6;
+						addr_len = 16;
+						break;
+				}
+
+				if (TCP_MAXOLEN - *optlen_ptr < address.length)
+					break;
+
+				/* mark address as advertised. Need to pass this back to the
+				 * mpcb */
+				to->to_mopts.add_addr_mask &= ~(1 << i);
+
+				*optlen_ptr += address.length;
+				*optp++ = TCPOPT_MPTCP;
+				*optp++ = address.length;
+
+				/* subtype and IPVer */
+				uint8_t subtype = (MPTCP_SUBTYPE_ADD_ADDR << 4);
+				subtype |= address.sub_ipver;
+				bcopy((u_char *)&subtype, optp, sizeof(uint8_t));
+				optp ++;
+
+				/* Minus 1 as we never send add_addr for the master subflow */
+				addr_id = i - 1;
+
+				/* Address ID */
+				bcopy((u_char *)&addr_id, optp, sizeof(uint8_t));
+				optp ++;
+
+				bcopy((u_char *)addr, optp, addr_len);
+				optp += addr_len;
+			}
+			break;
+		}
+		case MPOF_REMOVE_ADDR:
+			break;
+		case MPOF_MP_FAIL:
+			break;
+		case MPOF_FASTCLOSE:
+			break;
+		default:
+			break;
+		}
+	}
+}
+
 /*
  * Tcp output routine: figure out what should be sent and send it.
  */
@@ -168,8 +540,10 @@
 tcp_output(struct tcpcb *tp)
 {
 	struct socket *so = tp->t_inpcb->inp_socket;
+	struct mpcb *mp = tp->t_mpcb;
 	long len, recwin, sendwin;
-	int off, flags, error = 0;	/* Keep compiler happy */
+	int off = 0, flags, map_offset = 0, error = 0;	/* Keep compiler happy */
+	struct ds_map *snd_dsmap;
 	struct mbuf *m;
 	struct ip *ip = NULL;
 	struct ipovly *ipov = NULL;
@@ -195,6 +569,7 @@
 #endif
 
 	INP_WLOCK_ASSERT(tp->t_inpcb);
+	KASSERT(mp != NULL, ("%s: mp NULL", __func__));
 
 #ifdef TCP_OFFLOAD
 	if (tp->t_flags & TF_TOE)
@@ -217,6 +592,7 @@
 			idle = 0;
 		}
 	}
+
 again:
 	/*
 	 * If we've recently taken a timeout, snd_max will be greater than
@@ -348,13 +724,11 @@
 	 */
 	if (sack_rxmit == 0) {
 		if (sack_bytes_rxmt == 0)
-			len = ((long)ulmin(sbavail(&so->so_snd), sendwin) -
-			    off);
+			len = ((long)ulmin(sbavail(&so->so_snd), sendwin) - off);
 		else {
 			long cwin;
 
-                        /*
-			 * We are inside of a SACK recovery episode and are
+			/* We are inside of a SACK recovery episode and are
 			 * sending new data, having retransmitted all the
 			 * data possible in the scoreboard.
 			 */
@@ -513,6 +887,13 @@
 
 	recwin = sbspace(&so->so_rcv);
 
+//	if (recwin > (long)TCP_MAXWIN) {
+//		printf("%s: recwin = sbspace = %ld scale %d \n", __func__, recwin,
+//		tp->rcv_scale);
+////		kdb_break();
+//	}
+
+
 	/*
 	 * Sender silly window avoidance.   We transmit under the following
 	 * conditions when len is non-zero:
@@ -710,6 +1091,7 @@
 	 */
 	if ((tp->t_flags & TF_NOOPT) == 0) {
 		to.to_flags = 0;
+		to.to_mopts.mpo_flags = 0;
 		/* Maximum segment size. */
 		if (flags & TH_SYN) {
 			tp->snd_nxt = tp->iss;
@@ -721,6 +1103,192 @@
 			to.to_wscale = tp->request_r_scale;
 			to.to_flags |= TOF_SCALE;
 		}
+        /* MPTCP options */
+		if (V_tcp_do_mptcp) {
+			if (flags & TH_SYN) {
+				/* Multipath announce capable, for SYN and SYN/ACK */
+				if (tp->t_sf_flags & SFF_SEND_MPCAPABLE) {
+					tp->t_sf_flags &= ~SFF_SEND_MPCAPABLE;
+					tp->t_sf_flags |= SFF_SENT_MPCAPABLE;
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_CAPABLE_SYN;
+					mp_process_local_key(&tp->t_mp_conn,
+					    mp_generate_local_key());
+					to.to_mopts.local_key = tp->t_mp_conn.local_key;
+				} else {
+					/* A SYN on a subflow that isn't the first, use
+					 * MP_JOIN. In this case an MP session has already
+					 * been established. */
+					tp->t_sf_state |= SFS_MP_CONNECTING;
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_MP_JOIN;
+					to.to_mopts.rcv_token =
+							tp->t_mp_conn.remote_token;
+					tp->t_mp_conn.local_rand = to.to_mopts.snd_rnd =
+					    arc4random();
+					to.to_mopts.addr_id = tp->t_addrid - 1;
+				}
+			}
+
+			/* received a SYNACK with MP_CAPABLE */
+			if (tp->t_sf_flags & SFF_GOT_SYNACK) {
+				tp->t_sf_flags &= ~SFF_GOT_SYNACK;
+				/* got a synack after sending capable */
+
+				if (tp->t_sf_flags & SFF_SENT_MPCAPABLE) {
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_CAPABLE_ACK;
+					to.to_mopts.local_key = tp->t_mp_conn.local_key;
+					to.to_mopts.remote_key = tp->t_mp_conn.remote_key;
+				}
+			}
+
+			/* Received a SYNACK with MP_JOIN */
+			if (tp->t_sf_flags & SFF_GOT_JOIN_SYNACK) {
+				/* XXXNJW: should clear this only when we know that the
+				 * option has been copied into a packet.
+				 */
+				tp->t_sf_flags &= ~SFF_GOT_JOIN_SYNACK;
+
+				/* XXXNJW: Should set this state only when we know the
+				 * option has been put into packet */
+				tp->t_sf_state |= SFS_MP_CONNECTING;
+
+				/* Must send full HMAC-A as third part of MP_JOIN
+				 * handshake */
+				to.to_mopts.snd_mac = tp->t_mp_conn.hmac_local;
+
+				/* Add an MP_JOIN_ACK to the outgoing packet */
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= MPOF_JOIN_SYNACK;
+			}
+
+		} else {
+			/* Need to init these even if not doing multipath, as the
+			 * accounting requires it. */
+//			MP_INNER_LOCK(tp->t_mpcb);
+//			mp_sendseqinit(tp->t_mpcb, tp);
+//			MP_INNER_UNLOCK(tp->t_mpcb);
+		}
+
+		/* Do these options only once mptcp is established. */
+		if (tp->t_sf_state & SFS_MP_ENABLED) {
+			/* XXXNJW:
+			 * A weird thing about this is that we only trigger
+			 * the advertisement of addresses in mp_do_output,
+			 * which is called under the MPP_LOCK. Hence for now
+			 * just pulling the address info directly out of the
+			 * mpcb. We should only ever enter into here while
+			 * under an MPP lock.
+			 *
+			 * Should replace this
+			 */
+			if (tp->t_sf_flags & SFF_SEND_ADD_ADDR) {
+				MPP_LOCK_ASSERT(tp->t_mpcb->mp_mppcb);
+				tp->t_sf_flags &= ~SFF_SEND_ADD_ADDR;
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= MPOF_ADD_ADDR;
+				to.to_mopts.add_addr_mask = tp->t_mpcb->mp_advaddr_mask;
+				to.to_mopts.address_count = tp->t_mpcb->mp_conn_address_count;
+				to.to_mopts.addr_id = tp->t_mpcb->subflow_cnt - 1;
+			}
+
+			/*
+			 * Need to attach a DATA-ACK to the outgoing packet
+			 * MPO_DATA_ACK is usually set in tcp_reass when in-order
+			 * data segments are provided to the process. currently
+			 * this works like an ACK_NOW, and will be put onto any
+			 * outgoing segment.
+			 *
+			 * XXX: provide a callout to do time-delayed Data-ACKs
+			 */
+			if (tp->t_sf_flags & SFF_NEED_DACK) {
+				tp->t_sf_flags &= ~SFF_NEED_DACK;
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= (MPOF_DATA_ACK | MPOF_DSS);
+				// should check against session settings
+				//to.to_mopts.mpo_flags |= MPOF_DSS;
+				//to.to_mopts.mpo_flags |= MPOF_ACK64;
+				to.to_mopts.data_ack_num =
+				    (uint32_t) tp->t_mp_conn.ds_ack_num;
+//				DACK value to be set in tcpcb by mp_output.
+			}
+
+			/* Connection is closing */
+			if (tp->t_sf_flags & SFF_NEED_DFIN) {
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= (MPOF_DATA_FIN | MPOF_DSS);
+
+				/* A DFIN with no payload requires:
+				 * - SSN == 0
+				 * - Data-len == 1
+				 * - DSN == The next DSN to send
+				 */
+				if (len == 0) {
+					to.to_mopts.mpo_flags |= MPOF_DSN_MAP;
+					to.to_mopts.mpo_flags |= MPOF_DSS;
+				    to.to_mopts.sub_seq_num = 0;
+				    to.to_mopts.dss_data_len = 1;
+
+				    /* mp_do_output pushes ds_snd_nxt by one when dfin
+				     * is set. There is no map with a zero-len segment
+				     * (typically dsn is based on map offset) so must
+				     * subtract '1' here to make sure we send the next
+				     * expected data-level byte.
+				     * XXXNJW: to fix */
+					to.to_mopts.data_seq_num =
+					    (uint32_t) tp->t_mp_conn.ds_snd_nxt - 1;
+
+					// change to use ds_snd_nxt specified by mp-layer
+					// (in e.g. tp->t_ds_snd_nxt)
+
+					snd_dsmap = NULL;
+				}
+			}
+
+			/* Find the ds map for this tcp sqn */
+		    snd_dsmap = (len) ? mp_find_dsmap(tp, tp->snd_nxt): NULL;
+
+			if (len)
+			    KASSERT(snd_dsmap != NULL,
+			        ("%s: mp enabled, have len but no map\n", __func__));
+
+			if (snd_dsmap != NULL) {
+     			map_offset = tp->snd_nxt - snd_dsmap->sf_seq_start;
+
+				/* Currently puts a DSN map on each packet. */
+				to.to_mopts.mpo_flags |= MPOF_DSN_MAP;
+
+				/* XXXNJW: Need to put in options for either mult-packet maps or
+				 * per-packet maps.
+				 *
+				 * Need to build a DSS MAP for the outgoing packet. Note that the
+				 * mapping here does not always map directly to the ds_map. In the
+				 * following case we are creating smaller maps for each segment
+				 * from the ds_map */
+				if (to.to_mopts.mpo_flags & MPOF_DSN_MAP) {
+					/* XXXNJW: implement checks for csum and dsn64 */
+					//to.to_mopts.mpo_flags |= MPOF_USE_CSUM;
+					//to.to_mopts.mpo_flags |= MPOF_DSN64;
+
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_DSS;
+
+					/* This will create a map for each segment, of length 'len' */
+					to.to_mopts.sub_seq_num =
+						(snd_dsmap->sf_seq_start + map_offset - tp->iss);
+					to.to_mopts.data_seq_num =
+						(uint32_t) snd_dsmap->ds_map_start + map_offset;
+					//to.to_mopts.dss_data_len = len;
+					if (to.to_mopts.data_seq_num == 0) {
+						printf("%s: dsn is 0 len %ld tsqn %u\n", __func__,
+						    len, tp->snd_nxt);
+					}
+
+				}
+			}
+		}
+
 		/* Timestamps. */
 		if ((tp->t_flags & TF_RCVD_TSTMP) ||
 		    ((flags & TH_SYN) && (tp->t_flags & TF_REQ_TSTMP))) {
@@ -750,10 +1318,22 @@
 			to.to_flags |= TOF_SIGNATURE;
 #endif /* TCP_SIGNATURE */
 
+		/* Clear MPTCP options from RST packets */
+		if (flags & TH_RST)
+		    to.to_flags &= ~TOF_MPTCP;
+
 		/* Processing the options. */
 		hdrlen += optlen = tcp_addoptions(&to, opt);
 	}
 
+	/* XXXNJW to remove */
+	/* update the address masks */
+	if (to.to_mopts.mpo_flags & MPOF_ADD_ADDR) {
+	    to.to_mopts.mpo_flags &= ~MPOF_ADD_ADDR;
+	    MPP_LOCK_ASSERT(tp->t_mpcb->mp_mppcb);
+	    tp->t_mpcb->mp_advaddr_mask = to.to_mopts.add_addr_mask;
+	}
+
 #ifdef INET6
 	if (isipv6)
 		ipoptlen = ip6_optlen(tp->t_inpcb);
@@ -906,6 +1486,54 @@
 	KASSERT(len + hdrlen + ipoptlen <= IP_MAXPACKET,
 	    ("%s: len > IP_MAXPACKET", __func__));
 
+	/* XXXNJW: This is a temporary hack way to adjust ds map length
+	 * after the options have been added. This is only applicable for
+	 * map-per-packet cases, where the length of the map is the length
+	 * of the transmitted segment.
+	 *
+	 * Should probably just have longer maps and include the same
+	 * map details multiple times until we've sent all the data covered
+	 * by that map?
+	 *
+	 * also need a better solution to segments overlapping map boundaries
+	 * than clamping down to map_remain
+	 */
+//	if (len && (tp->t_sf_state & SFS_MP_ENABLED)) {
+//	    long unsent = snd_dsmap->ds_map_len - map_offset;
+//	    len = min((uint32_t)len, unsent);
+//	    to.to_mopts.dss_data_len = htons((uint16_t)len);
+//	}
+//
+//	/* Now copy the length into the length field od the DSS option */
+//	if ((tp->t_sf_state & SFS_MP_ENABLED) &&
+//	    (to.to_mopts.mpo_flags & MPOF_DSS)) {
+//		if(to.to_mopts.dss_data_len)
+//			bcopy((u_char *)&to.to_mopts.dss_data_len,
+//				to.to_mopts.dss_data_len_p, sizeof(to.to_mopts.dss_data_len));
+//	}
+
+	if ((tp->t_sf_state & SFS_MP_ENABLED) && (to.to_flags & TOF_MPTCP)) {
+		long unsent = 0;
+		if (len) {
+	        unsent = snd_dsmap->ds_map_len - map_offset;
+			if(unsent == 0) {
+				printf("%s: len %ld unsent %ld, ds_map_len %d\n",
+				    __func__, len, unsent, (uint32_t) snd_dsmap->ds_map_len);
+				kdb_break();
+			}
+	        len = min((uint32_t)len, unsent);
+	        to.to_mopts.dss_data_len = htons((uint16_t)len);
+	        bcopy((u_char *)&to.to_mopts.dss_data_len,
+				to.to_mopts.dss_data_len_p, sizeof(to.to_mopts.dss_data_len));
+		} else if (tp->t_sf_flags & SFF_NEED_DFIN) {
+		    to.to_mopts.dss_data_len =
+		        htons((uint16_t)to.to_mopts.dss_data_len);
+		    bcopy((u_char *)&to.to_mopts.dss_data_len,
+				to.to_mopts.dss_data_len_p, sizeof(to.to_mopts.dss_data_len));
+		}
+		tp->t_sf_flags &= ~SFF_NEED_DFIN; /* XXXNJW: a workaround */
+	}
+
 /*#ifdef DIAGNOSTIC*/
 #ifdef INET6
 	if (max_linkhdr + hdrlen > MCLBYTES)
@@ -1651,6 +2279,15 @@
 				 *optp++ = 0;
 			break;
 			}
+		case TOF_MPTCP:
+			{
+			while (optlen % 2) {
+				optlen += TCPOLEN_NOP;
+				*optp++ = TCPOPT_NOP;
+			}
+			mp_addoptions(to, &optlen, optp);
+			break;
+			}
 		case TOF_SACK:
 			{
 			int sackblks = 0;
diff -r 1d1c4c997b66 sys/netinet/tcp_reass.c
--- a/sys/netinet/tcp_reass.c	Tue Jul 07 20:31:09 2015 +0000
+++ b/sys/netinet/tcp_reass.c	Sun Aug 30 14:27:42 2015 +1000
@@ -37,6 +37,7 @@
 #include "opt_tcpdebug.h"
 
 #include <sys/param.h>
+#include <sys/kdb.h>
 #include <sys/kernel.h>
 #include <sys/malloc.h>
 #include <sys/mbuf.h>
@@ -69,6 +70,8 @@
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
+#include <netinet/mptcp_var.h>
+
 #include <netinet6/tcp6_var.h>
 #include <netinet/tcpip.h>
 
@@ -97,6 +100,7 @@
 {
 	struct socket *so = tp->t_inpcb->inp_socket;
 	struct mbuf *mq, *mp;
+	struct mbuf *last_seg;
 	int flags, wakeup;
 
 	INP_WLOCK_ASSERT(tp->t_inpcb);
@@ -214,42 +218,71 @@
 		mq = nq;
 	}
 
+	/* Insert the new segment queue entry into place. */
+//	if (mp) {
+//		if (M_TCPHDR(mp)->th_seq + mp->m_pkthdr.len == th->th_seq)
+//			m_catpkt(mp, m);
+//		else {
+//			m->m_nextpkt = mp->m_nextpkt;
+//			mp->m_nextpkt = m;
+//			m->m_pkthdr.pkt_tcphdr = th;
+//		}
+//	} else {
+//		mq = tp->t_segq;
+//		tp->t_segq = m;
+//		if (mq && th->th_seq + *tlenp == M_TCPHDR(mq)->th_seq) {
+//			m->m_nextpkt = mq->m_nextpkt;
+//			mq->m_nextpkt = NULL;
+//			m_catpkt(m, mq);
+//		} else
+//			m->m_nextpkt = mq;
+//		m->m_pkthdr.pkt_tcphdr = th;
+//	}
+
 	/*
-	 * Insert the new segment queue entry into place.  Try to collapse
-	 * mbuf chains if segments are adjacent.
+	 * Insert the new segment queue entry into place.
+     *
+     * XXXNJW: Segments that are adjacent at TCP-level might not represent
+     * contiguous bytes at the data-level, thus don't collapse the segments
+     * in MPTCP, as we need to retain the mbuf header and DSN tag for later
+     * data-level reassembly
 	 */
 	if (mp) {
-		if (M_TCPHDR(mp)->th_seq + mp->m_pkthdr.len == th->th_seq)
-			m_catpkt(mp, m);
-		else {
-			m->m_nextpkt = mp->m_nextpkt;
-			mp->m_nextpkt = m;
-			m->m_pkthdr.pkt_tcphdr = th;
-		}
+		m->m_nextpkt = mp->m_nextpkt;
+		mp->m_nextpkt = m;
 	} else {
 		mq = tp->t_segq;
 		tp->t_segq = m;
-		if (mq && th->th_seq + *tlenp == M_TCPHDR(mq)->th_seq) {
-			m->m_nextpkt = mq->m_nextpkt;
-			mq->m_nextpkt = NULL;
-			m_catpkt(m, mq);
-		} else
-			m->m_nextpkt = mq;
+		m->m_nextpkt = mq;
 		m->m_pkthdr.pkt_tcphdr = th;
 	}
 	tp->t_segqlen += *tlenp;
 
 present:
+
+//    if (th) {
+//		if (th->th_seq != tp->rcv_nxt)
+//			printf("%s: present - rcv_nxt %u tseq %u tp %p\n", __func__,
+//				tp->rcv_nxt, th->th_seq, tp);
+//    }
+
+//
+//    if(tp->t_segq)
+//    	printf("%s: first seg %u\n", __func__,
+//    	    (uint32_t) M_TCPHDR(tp->t_segq)->th_seq);
+
 	/*
-	 * Present data to user, advancing rcv_nxt through
+	 * Adjust accounting advancing rcv_nxt through
 	 * completed sequence space.
 	 */
 	if (!TCPS_HAVEESTABLISHED(tp->t_state))
 		return (0);
 
+	KASSERT(tp->t_segq_received == NULL,
+	    ("%s: t_segq_received not NULL\n", __func__));
+
+    wakeup = 0;
 	flags = 0;
-	wakeup = 0;
-	SOCKBUF_LOCK(&so->so_rcv);
 	while ((mq = tp->t_segq) != NULL &&
 	    M_TCPHDR(mq)->th_seq == tp->rcv_nxt) {
 		tp->t_segq = mq->m_nextpkt;
@@ -262,14 +295,47 @@
 			m_freem(mq);
 		else {
 			mq->m_nextpkt = NULL;
-			sbappendstream_locked(&so->so_rcv, mq, 0);
-			wakeup = 1;
+			/* Now queue up the segment in the received list. On return
+			 * t_segq_received is assigned to a local-scope pointer and
+			 * set to NULL. The pointer is enqueued in mp_input_segq */
+			if (tp->t_segq_received) {
+				last_seg->m_nextpkt = mq;
+				last_seg = mq;
+			} else {
+				tp->t_segq_received = mq;
+				last_seg = tp->t_segq_received;
+			}
 		}
 	}
-	ND6_HINT(tp);
-	if (wakeup)
-		sorwakeup_locked(so);
-	else
-		SOCKBUF_UNLOCK(&so->so_rcv);
+
 	return (flags);
 }
+
+
+
+/* cleanup segments that have been bypassed (e.g. due to rexmit
+ * The mp_reass code might actually do something like this for us,
+ * since insertion of the segment into the data-level list will trim/drop
+ * segments.
+ *
+ * NB: very late segments will still need to be handled in mp_reass (i.e. if
+ * they are less than ds_rcv_nxt)
+ *
+ */
+
+///* Get mbuf tag with DSN */
+//mtag =  m_tag_locate(mq, PACKET_COOKIE_MPTCP, PACKET_TAG_DSN, NULL);
+//KASSERT(mtag != NULL, ("%s segment %u missing an mbuf tag\n",
+//    __func__, th->th_seq));
+//m_dsn = ((struct dsn_tag *)mtag)->dsn;
+//
+///* Has this segment been bypassed at the data-level, and already
+// * acked at the subflow level? */
+//if (m_dsn < tp->t_mpcb->ds_rcv_nxt &&
+//    M_TCPHDR(mq)->th_seq < tp->rcv_nxt) {
+//	tp->t_segq = mq->m_nextpkt;
+//	tp->t_segqlen -= mq->m_pkthdr.len;
+//	m_freem(mq);
+//	continue;
+//}
+
